#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK16x16x16NT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=16, NB=16, KB=16, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + 32;
   const float *stN = B + 32;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((lda) << 5)), incAn = -32;
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 5));
   #define incBn 2
   #define incCm 2
   const int incCn = (((ldc) << 1)) - 32;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 = rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=15; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
